Graphics 800, 600, 0, 2
SetBuffer BackBuffer()

Include "Lua_Include.bb"

Include "Lua_Include.bb"

L = LuaL_NewState() ;Create new state
LuaL_OpenLibs( L )  ;Load standard libraries
Lua_InitInterface( L, "CallFunction" ) ;Initialize call interface

Status = LuaL_LoadFile( L, "Example 2.lua" ) ;Load script
If Status Then RuntimeError "Error loading script!" + Chr( 10 ) + Lua_ToString( L, 1 )

Lua_PushInteger( L, 45 ) ;Push 45 onto the lua stack
Lua_SetGlobal( L, "Foo" ) ;Create new global "Foo" with value 45

Lua_NewTable( L ) ;Create new table
Index = Lua_GetTop( L ) ;Save stack index of the table for later use

For i = 1 To 10
	Lua_PushNumber( L, i*4 ) ;Push new value onto the stack
	Lua_RawSetI( L, Index, i ) ;Set topmost stack element as the ith element of the table at Index
Next

Lua_SetGlobal( L, "Table" ) ;Create new global containing the table we just created

Status = Lua_PCall( L, 0, 0, 0 ) ;Execute script
If Status Then RuntimeError "Error executing script!" + Chr( 10 ) + Lua_ToString( L, 1 )

Lua_Close( L ) ;Close state

Flip
WaitKey()
End

Function Lua_UserFunction()
	L = Lua_GetCurrentState() ;Get the lua state this function was called from
	
	FuncName$ = Lua_ToString( L, 1 ) ;Get the function lua wants to call
	
	Select FuncName$
		Case "Print" 
			Print Lua_ToString( L, 2 ) ;Read second parameter and print it
			Lua_SetResults( 0 ) ;No return values
		Case "Line"
			Line Lua_ToNumber( L, 2 ), Lua_ToNumber( L, 3 ), Lua_ToNumber( L, 4 ), Lua_ToNumber( L, 5 ) ;Read all 4 arguments and draw a line
			Lua_SetResults( 0 ) ;No return values
		Case "Millisecs"
			Lua_PushInteger( L, MilliSecs() ) ;Push Millisecs() value onto the stack
			Lua_SetResults( 1 ) ;Return one value
		Case "GetDate"
			Date$ = CurrentDate()
			Lua_PushString( L, Left( Date$, 2 ) ) ;Split date into day/month/year and push it onto the stack
			Lua_PushString( L, Mid( Date$, 4, 3 ) )
			Lua_PushString( L, Right( Date$, 4 ) )
			Lua_SetResults( 3 ) ;Return three values
	End Select
End Function