;Note: When calling Lua_Call, the topmost element of the stack must be a compiled script
;You can either load the script from file each time or execute it from a string or a bank instead

Graphics 800, 600, 0, 2
SetBuffer BackBuffer()

Include "Lua_Include.bb"

L = LuaL_NewState()
LuaL_OpenLibs( L ) ;No interface required, since the test script doesn't call any of our functions


;Create bank containing the script
ScriptSize = FileSize( "Example 3.lua" )
ScriptBank = CreateBank( ScriptSize )

Instream = ReadFile( "Example 3.lua" )
ReadBytes ScriptBank, Instream, 0, ScriptSize
CloseFile Instream

Lua_PushNumber( L, 0 )
Lua_SetGlobal( L, "Angle" )
Lua_PushNumber( L, 0 )
Lua_SetGlobal( L, "RectX" )
Lua_PushNumber( L, 0 )
Lua_SetGlobal( L, "RectY" )

Timer = CreateTimer( 60 )
While Not KeyHit( 1 )
	Cls
	
	Status = LuaL_LoadBuffer( L, ScriptBank, ScriptSize, "Testscript" ) ;Load script from buffer
	If Status Then RuntimeError "Error loading script!" + Chr( 10 ) + Lua_ToString( L, 1 )
	
	Status = Lua_PCall( L, 0, 0, 0 ) ;Execute it
	If Status Then RuntimeError "Error executing script!" + Chr( 10 ) + Lua_ToString( L, 1 )
	
	Lua_GetGlobal( L, "RectX" ) ;Read global values set by the script
	RectX# = Lua_ToNumber( L, -1 )
	Lua_GetGlobal( L, "RectY" )
	RectY# = Lua_ToNumber( L, -1 )
	
	Lua_Pop( L, 2 ) ;Pop the two elements we just pushed with Lua_GetGlobal to avoid stack overflow
	
	Rect RectX#, RectY#, 20, 20 ;Draw rectangle
	
	Flip 0
	WaitTimer Timer
Wend

Lua_Close( L ) ;Close state
WaitKey()
End

Function Lua_UserFunction()
	;The script doesn't call any of our functions, so we leave this empty
End Function