Global Lua_FirstCall = True

Const LUA_REGISTRYINDEX		= -10000
Const LUA_ENVIRONINDEX		= -10001
Const LUA_GLOBALSINDEX		= -10002

Const LUA_TNONE				= -1
Const LUA_TNIL				=  0
Const LUA_TBOOLEAN			=  1
Const LUA_TLIGHTUSERDATA	=  2
Const LUA_TNUMBER			=  3
Const LUA_TSTRING			=  4
Const LUA_TTABLE			=  5
Const LUA_TFUNCTION			=  6
Const LUA_TUSERDATA			=  7
Const LUA_TTHREAD			=  8

Const LUA_MULRET 			= -1

Const LUA_GCSTOP			=  0
Const LUA_GCRESTART			=  1
Const LUA_GCCOLLECT			=  2
Const LUA_GCCOUNT			=  3
Const LUA_GCCOUNTB			=  4
Const LUA_GCSTEP			=  5
Const LUA_GCSETPAUSE		=  6
Const LUA_GCSETSTEPMUL		=  7

Function Lua_Pop( L, N )
	Lua_SetTop( L, -(N)-1 )
End Function

Function Lua_SetGlobal( L, S$ )
	Lua_SetField( L, LUA_GLOBALSINDEX, S$ )
End Function

Function Lua_GetGlobal( L, S$ )
	Lua_GetField( L, LUA_GLOBALSINDEX, S$ )
End Function

Function Lua_NewTable( L )
	Lua_CreateTable( L, 0, 0 )
End Function

Function Lua_ToString$( L, N )
	Return Lua_ToLString( L, N, 0 )
End Function

Function Lua_IsFunction( L, N )
	Return ( Lua_Type( L, N ) = LUA_TFUNCTION )
End Function

Function Lua_IsTable( L, N )
	Return ( Lua_Type( L, N ) = LUA_TTABLE )
End Function

Function Lua_IsLightUserData( L, N )
	Return ( Lua_Type( L, N ) = LUA_TLIGHTUSERDATA )
End Function

Function Lua_IsNil( L, N )
	Return ( Lua_Type( L, N ) = LUA_TNIL )
End Function

Function Lua_IsBoolean( L, N )
	Return ( Lua_Type( L, N ) = LUA_TBOOLEAN )
End Function

.Lua_GetPointer
	Lua_SaveInstructionPointer()
	
	If Lua_FirstCall Then
		Lua_FirstCall = False
	Else
		Lua_UserFunction()
		Return
	EndIf